package dsl.modelwithelements;

import dsl.modelwithelements.ModelWithElementsMatcher;
import org.eclipse.viatra2.emf.incquery.runtime.api.IncQueryEngine;
import org.eclipse.viatra2.emf.incquery.runtime.api.impl.BaseGeneratedMatcherFactory;
import org.eclipse.viatra2.emf.incquery.runtime.exception.IncQueryException;
import org.eclipse.viatra2.emf.incquery.runtime.extensibility.IMatcherFactoryProvider;

/**
 * A pattern-specific matcher factory that can instantiate ModelWithElementsMatcher in a type-safe way.
 * 
 * @see ModelWithElementsMatcher
 * @see ModelWithElementsMatch
 * 
 */
public class ModelWithElementsMatcherFactory extends BaseGeneratedMatcherFactory<ModelWithElementsMatcher> {
  /**
   * @return the singleton instance of the matcher factory
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static ModelWithElementsMatcherFactory instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected ModelWithElementsMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return new ModelWithElementsMatcher(engine);
    
  }
  
  @Override
  protected String getBundleName() {
    return "dslQuery";
    
  }
  
  @Override
  protected String patternName() {
    return "dsl.modelWithElements";
    
  }
  
  private ModelWithElementsMatcherFactory() throws IncQueryException {
    super();
  }
  public static class Provider implements IMatcherFactoryProvider<ModelWithElementsMatcherFactory> {
    @Override
    public ModelWithElementsMatcherFactory get() throws IncQueryException {
      return instance();
    }
  }
  
  private static class LazyHolder {
    private final static ModelWithElementsMatcherFactory INSTANCE = make();
    
    public static ModelWithElementsMatcherFactory make() {
      try {
      	return new ModelWithElementsMatcherFactory();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
