package dsl.modelwithelements;

import dsl.modelwithelements.ModelWithElementsMatch;
import org.eclipse.viatra2.emf.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the modelWithElements pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
public abstract class ModelWithElementsProcessor implements IMatchProcessor<ModelWithElementsMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pM the value of pattern parameter m in the currently processed match 
   * 
   */
  public abstract void process(final Object m);
  
  @Override
  public void process(final ModelWithElementsMatch match) {
    process(match.getM());  				
    
  }
}
