package dsl.modelwithoutelements;

import dsl.modelwithoutelements.ModelWithoutElementsMatcher;
import org.eclipse.viatra2.emf.incquery.runtime.api.IncQueryEngine;
import org.eclipse.viatra2.emf.incquery.runtime.api.impl.BaseGeneratedMatcherFactory;
import org.eclipse.viatra2.emf.incquery.runtime.exception.IncQueryException;
import org.eclipse.viatra2.emf.incquery.runtime.extensibility.IMatcherFactoryProvider;

/**
 * A pattern-specific matcher factory that can instantiate ModelWithoutElementsMatcher in a type-safe way.
 * 
 * @see ModelWithoutElementsMatcher
 * @see ModelWithoutElementsMatch
 * 
 */
public class ModelWithoutElementsMatcherFactory extends BaseGeneratedMatcherFactory<ModelWithoutElementsMatcher> {
  /**
   * @return the singleton instance of the matcher factory
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static ModelWithoutElementsMatcherFactory instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected ModelWithoutElementsMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return new ModelWithoutElementsMatcher(engine);
    
  }
  
  @Override
  protected String getBundleName() {
    return "dslQuery";
    
  }
  
  @Override
  protected String patternName() {
    return "dsl.modelWithoutElements";
    
  }
  
  private ModelWithoutElementsMatcherFactory() throws IncQueryException {
    super();
  }
  public static class Provider implements IMatcherFactoryProvider<ModelWithoutElementsMatcherFactory> {
    @Override
    public ModelWithoutElementsMatcherFactory get() throws IncQueryException {
      return instance();
    }
  }
  
  private static class LazyHolder {
    private final static ModelWithoutElementsMatcherFactory INSTANCE = make();
    
    public static ModelWithoutElementsMatcherFactory make() {
      try {
      	return new ModelWithoutElementsMatcherFactory();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
