package dsl.modelwithoutelements;

import dsl.modelwithoutelements.ModelWithoutElementsMatch;
import org.eclipse.viatra2.emf.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the modelWithoutElements pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
public abstract class ModelWithoutElementsProcessor implements IMatchProcessor<ModelWithoutElementsMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pM the value of pattern parameter m in the currently processed match 
   * 
   */
  public abstract void process(final Object m);
  
  @Override
  public void process(final ModelWithoutElementsMatch match) {
    process(match.getM());  				
    
  }
}
